use super::*;

mod query; pub use query::WindowQuery;
mod config; pub use config::WindowConfig;
mod internal; use internal::Internal;

pub struct WindowManager {
    channel:Sender<Query>,
}


impl WindowManager {
    pub fn create(&mut self) -> Result<(),()>
    {
        self.channel.send(Query::new(
            Some(self.channel.clone()),
            QueryData::Window(WindowQuery::Create {
                
            }
        ))).ok();

        Err(())
    }
}

impl Subsystem for WindowManager {

    fn start() -> Result<Sender<Query>, crate::Error>
    {
        let (tx, rx) = channel::bounded::<Query>(24);

        let sys_tx = tx.clone();
        std::thread::spawn(move || {
            Internal::thread(sys_tx, rx);
        });

        Ok(tx)
    }
}

impl From<Sender<Query>> for WindowManager {
    fn from(channel :Sender<Query>) -> Self {
        Self {
            channel
        }
    }
}
